       		Title  "Enterprise Nacelle Program"

        list P=16F648A
;
; ------------------
; CONFIGURATION FUSE
; ------------------
;
    INCLUDE "p16f648a.inc"
	__CONFIG _BODEN_OFF & _CP_OFF & _DATA_CP_OFF & _PWRTE_OFF & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT

;;; This program controls LEDs for a model of the Enterprise from
;;; Star Trek.  It operates one nacelle worth of LEDs (10 LEDs) on
;;; lines 0-4 of ports A and B, and also drives the navigational blinkers
;;; on RA7.
;;; This is a mid-development snapshot.  So far I have opposing inverted
;;; chasers (representing the spinning doo-hickey).  From here I need to
;;; add the random flashing behavior of the PORTB (multicolored) LEDs, as
;;; well as add flashers for the navigational lights

DelayL equ 0x20
DelayM equ 0x21
Count equ 0x22
LedSelect equ 0x23
LedMask equ 0x24
BufferA equ 0x25
BufferB equ 0x26
Temp equ 0x27


ClearFlags Macro
        movlw 0x0f8
        andwf STATUS, w
        movwf STATUS
        endm

;
; -------------
; PROGRAM START
; -------------
;
	org 0h			; startup address = 0000

        clrf PORTA
        clrf PORTB
        movlw 0x07
        movwf CMCON
        bcf STATUS, RP1
	bsf STATUS,RP0		; set RP0 for RAM page 1
	movlw b'00000000'		; all PortA = outputs
	movwf TRISA
	movlw b'00000000'		; all PortB = outputs
	movwf TRISB
	bcf STATUS,RP0		; set RP0 for RAM page 0
        movlw 0x0a
        movwf Count

MainLoop
        call Delay100
        decf Count, 1
        movf Count, w
        movwf LedSelect
        rrf LedSelect, 1

        movlw 0
        movwf BufferA
        movwf BufferB

        movlw 1
        movwf LedMask
        ClearFlags
        movf LedSelect, w
LedMaskLoop
        btfsc STATUS, Z
        goto LedMaskDone
        rlf LedMask, f
        decf LedSelect, f
        goto LedMaskLoop
LedMaskDone
        btfsc Count, 0
        goto SetBufferB
SetBufferA
        movf LedMask, w
        movwf BufferA
        movwf Temp
        rlf LedMask, f
        rlf LedMask, f
        rrf Temp, f
        rrf Temp, f
        rrf Temp, f
        movf Temp, w
        iorwf LedMask, w
        andlw 0x1f
        movwf BufferB
        goto SetPorts
SetBufferB
        movf LedMask, w
        movwf BufferB
        movwf Temp
        rlf LedMask, f
        rlf LedMask, f
        rlf LedMask, f
        rrf Temp, f
        rrf Temp, f
        movf Temp, w
        iorwf LedMask, w
        andlw 0x1f
        movwf BufferA
        goto SetPorts
SetPorts
        movlw 0xff
        xorwf BufferA, f
        xorwf BufferB, f

        movf BufferA, w
        movwf PORTA
        movf BufferB, w
        movwf PORTB

        ClearFlags
        movf Count, w
        btfss STATUS, Z
        goto MainLoop
        movlw 0x0a
        movwf Count
        goto MainLoop


Delay100
        clrf DelayL
        movlw 0x20
        movwf DelayM
Wait1
        decfsz DelayL, 1
        goto Wait1
        decfsz DelayM, 1
        goto Wait1
        return


        end
